#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
    if (m_menu) {
        m_menu->deleteLater();
        m_menu = nullptr;
    }
}

void MainWindow::contextMenuEvent(QContextMenuEvent *event)
{
    Q_UNUSED(event)
    m_menu = new QMenu(this);
    QAction *act1 = new QAction(m_menu);
    act1->setText("actionOne");

    QString temp = "actionTwo-this-is-a-long-action-and-show-the-full-name-by-tips";
    QAction *act2 = new QAction(m_menu);
    QFontMetrics m_fm = QFontMetrics(QAction().font());
    const QString &&elidedName = m_fm.elidedText(temp, Qt::ElideRight, 100);
    act2->setText(elidedName);
    if (elidedName != temp)
        act2->setToolTip(temp);

    m_menu->addAction(act1);
    m_menu->addAction(act2);

    m_menu->setToolTipsVisible(true);
    m_menu->setFixedSize(QSize(200,200));
    QPoint t_tmpPoint = QCursor::pos();
    m_menu->popup(t_tmpPoint);
    m_menu->show();
}
